searchNodes=[{"doc":"JSON-RPC 2.0 plug JSONRPC2Plug is an Elixir library for a JSON-RPC 2.0 server. Can be used as the plug middleware or as a standalone transport-agnostic server handler. Installation The package can be installed by adding jsonrpc2_plug to your list of dependencies in mix.exs : def deps do [ { :jsonrpc2_plug , &quot;~&gt; 0.1.0&quot; } ] end Usage Defining Services Services should use JSONRPC2Plug.Service , which allows describing methods of service. Each method is a module which use JSONRPC2Plug.Method . Examples: defmodule CalculatorService do use JSONRPC2Plug.Service method &quot;add&quot; , AddMethod method &quot;subtract&quot; , SubtractMethod method &quot;multiply&quot; , MultiplyMethod method &quot;divide&quot; , DivideMethod end defmodule AddMethod do use JSONRPC2Plug.Method end # and so on... Defining Methods There are two possible ways to execute a request: call and cast . The first assumes the response which the service will return, the second does not. The module should implement at least one handle_call or handle_cast callback function to handle requests. defmodule AddMethod do use JSONRPC2Plug.Method # It handles requests like this: # {&quot;id&quot;: &quot;123&quot;, &quot;method&quot;: &quot;add&quot;, &quot;params&quot;: {&quot;x&quot;: 10, &quot;y&quot;: 20}, &quot;jsonrpc&quot;: &quot;2.0&quot;} def handle_call ( %{ &quot;x&quot; = &gt; x , &quot;y&quot; =&gt; y } , _conn ) do { :ok , x + y } end end The first argument is the &quot;params&quot; data comes from request JSON. According to JSONRPC2 spec , it must be either object or an array of arguments. The second argument is the Plug.Conn struct. Sometimes it could be useful to access the Plug connection. The module implements behaviour JSONRPC2Plug.Method which consists of five callbacks: handle_call , handle_cast , validate , handle_error and, handle_exception . handle_call and handle_cast TODO: Add description validate This function is for the validation of the input dataset. import JSONRPC2Plug.Validator , only : [ type : 1 , required : 0 ] def validate ( params ) do params |&gt; Validator . validate ( &quot;x&quot; , [ type ( :integer ) , required ( ) ] ) |&gt; Validator . validate ( &quot;y&quot; , [ type ( :integer ) , required ( ) ] ) |&gt; Validator . unwrap ( ) end The library has its own validator. It has 8 built-in validations: type , required , not_empty , exclude , include , len , number and format . However, you can write custom validations and extend existing ones. Moreover, you can use any preferred validator (eg. valdi ), but you should respect the following requirements: the validate function should return either {:ok, params} or {:invalid, errors} . Where errors could be any type that can be safely encoded to JSON and params is params to pass into handle_call or handle_cast functions. handle_error and handle_exception TODO: Add description Add as a plug to the router TODO: Add description Using as standalone module TODO: Add description Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/jsonrpc2_plug .","ref":"JSONRPC2Plug.html","title":"JSONRPC2Plug","type":"module"},{"doc":"HTTP entry point to JSONRPC 2.0 services. It's usual plug and accepts service handler module as a param. Example: use Plug.Router forward &quot;/jsonrpc&quot; , to : JSONRPC2Plug , init_opts : CalculatorService","ref":"JSONRPC2Plug.html#call/2","title":"JSONRPC2Plug.call/2","type":"function"},{"doc":"Send an error encoded according to JSONRPC 2.0 spec. It can be useful for global error handler in the router. Example: forward &quot;/jsonrpc&quot; , to : JSONRPC2Plug , init_opts : CalculatorService @impl Plug.ErrorHandler def handle_errors ( conn , %{ kind : kind , reason : reason , stack : stacktrace } ) do Logger . error ( Exception . format ( kind , reason , stacktrace ) ) case conn do %{ request_path : &quot;/jsonrpc&quot; } -&gt; JSONRPC2Plug . send_error ( conn , kind , reason ) _ -&gt; send_resp ( conn , 500 , &quot;Someting went wrong&quot; ) end end","ref":"JSONRPC2Plug.html#send_error/3","title":"JSONRPC2Plug.send_error/3","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Error.html","title":"JSONRPC2Plug.Error","type":"module"},{"doc":"","ref":"JSONRPC2Plug.Error.html#code2error/1","title":"JSONRPC2Plug.Error.code2error/1","type":"function"},{"doc":"Create error struct with predefined errors. Example: iex&gt; Error . new ( &quot;123&quot; , :invalid_request ) % Error { id : &quot;123&quot; , error : %{ code : - 32600 , message : &quot;Invalid request&quot; } , jsonrpc : &quot;2.0&quot; }","ref":"JSONRPC2Plug.Error.html#new/2","title":"JSONRPC2Plug.Error.new/2","type":"function"},{"doc":"Create error struct. Example: iex&gt; Error . new ( &quot;123&quot; , :invalid_params , %{ &quot;x&quot; =&gt; [ &quot;is not a integer&quot; ] } ) % Error { id : &quot;123&quot; , error : %{ code : - 32602 , message : &quot;Invalid params&quot; , data : %{ &quot;x&quot; =&gt; [ &quot;is not a integer&quot; ] } } , jsonrpc : &quot;2.0&quot; } iex&gt; Error . new ( &quot;123&quot; , 500 , &quot;Some valuable error&quot; ) % Error { id : &quot;123&quot; , error : %{ code : 500 , message : &quot;Some valuable error&quot; } , jsonrpc : &quot;2.0&quot; }","ref":"JSONRPC2Plug.Error.html#new/3","title":"JSONRPC2Plug.Error.new/3","type":"function"},{"doc":"Create error struct with custom errors. Example: iex&gt; Error . new ( &quot;123&quot; , 500 , &quot;Some valuable error&quot; , &quot;details&quot; ) % Error { id : &quot;123&quot; , error : %{ code : 500 , message : &quot;Some valuable error&quot; , data : &quot;details&quot; } , jsonrpc : &quot;2.0&quot; }","ref":"JSONRPC2Plug.Error.html#new/4","title":"JSONRPC2Plug.Error.new/4","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Error.html#t:code/0","title":"JSONRPC2Plug.Error.code/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Error.html#t:data/0","title":"JSONRPC2Plug.Error.data/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Error.html#t:error/0","title":"JSONRPC2Plug.Error.error/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Error.html#t:id/0","title":"JSONRPC2Plug.Error.id/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Error.html#t:message/0","title":"JSONRPC2Plug.Error.message/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Error.html#t:raw_code/0","title":"JSONRPC2Plug.Error.raw_code/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Error.html#t:t/0","title":"JSONRPC2Plug.Error.t/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Method.html","title":"JSONRPC2Plug.Method","type":"behaviour"},{"doc":"","ref":"JSONRPC2Plug.Method.html#handle/3","title":"JSONRPC2Plug.Method.handle/3","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Method.html#c:handle_call/2","title":"JSONRPC2Plug.Method.handle_call/2","type":"callback"},{"doc":"","ref":"JSONRPC2Plug.Method.html#c:handle_cast/2","title":"JSONRPC2Plug.Method.handle_cast/2","type":"callback"},{"doc":"","ref":"JSONRPC2Plug.Method.html#c:handle_error/3","title":"JSONRPC2Plug.Method.handle_error/3","type":"callback"},{"doc":"","ref":"JSONRPC2Plug.Method.html#c:handle_exception/3","title":"JSONRPC2Plug.Method.handle_exception/3","type":"callback"},{"doc":"","ref":"JSONRPC2Plug.Method.html#c:validate/1","title":"JSONRPC2Plug.Method.validate/1","type":"callback"},{"doc":"","ref":"JSONRPC2Plug.Method.html#t:result/0","title":"JSONRPC2Plug.Method.result/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Request.html","title":"JSONRPC2Plug.Request","type":"module"},{"doc":"Build request struct from input data Example: iex&gt; Request . parse ( %{ &quot;id&quot; =&gt; 123 , &quot;method&quot; =&gt; &quot;add&quot; , &quot;params&quot; =&gt; %{ &quot;x&quot; =&gt; 15 , &quot;y&quot; =&gt; 51 } , &quot;jsonrpc&quot; =&gt; &quot;2.0&quot; } ) { :ok , % Request { id : 123 , method : &quot;add&quot; , params : %{ &quot;x&quot; =&gt; 15 , &quot;y&quot; =&gt; 51 } , &quot;jsonrpc&quot; =&gt; &quot;2.0&quot; } } iex&gt; Request . parse ( %{ &quot;id&quot; =&gt; nil , &quot;method&quot; =&gt; &quot;add&quot; , &quot;params&quot; =&gt; %{ &quot;x&quot; =&gt; 15 , &quot;y&quot; =&gt; 51 } , &quot;jsonrpc&quot; =&gt; &quot;2.0&quot; } ) { :ok , % Request { id : nil , method : &quot;add&quot; , params : %{ &quot;x&quot; =&gt; 15 , &quot;y&quot; =&gt; 51 } , &quot;jsonrpc&quot; =&gt; &quot;2.0&quot; } } iex&gt; Request . parse ( %{ &quot;id&quot; =&gt; 123 , &quot;method&quot; =&gt; &quot;add&quot; , &quot;params&quot; =&gt; %{ &quot;x&quot; =&gt; 15 , &quot;y&quot; =&gt; 51 } } ) { :invalid , 123 } iex&gt; Request . parse ( %{ &quot;method&quot; =&gt; &quot;add&quot; , &quot;params&quot; =&gt; %{ &quot;x&quot; =&gt; 15 , &quot;y&quot; =&gt; 51 } , &quot;jsonrpc&quot; =&gt; &quot;2.0&quot; } ) { :invalid , nil }","ref":"JSONRPC2Plug.Request.html#parse/1","title":"JSONRPC2Plug.Request.parse/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Request.html#valid?/1","title":"JSONRPC2Plug.Request.valid?/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Request.html#t:id/0","title":"JSONRPC2Plug.Request.id/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Request.html#t:method/0","title":"JSONRPC2Plug.Request.method/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Request.html#t:params/0","title":"JSONRPC2Plug.Request.params/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Request.html#t:t/0","title":"JSONRPC2Plug.Request.t/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Response.html","title":"JSONRPC2Plug.Response","type":"module"},{"doc":"","ref":"JSONRPC2Plug.Response.html#new/2","title":"JSONRPC2Plug.Response.new/2","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Response.html#t:id/0","title":"JSONRPC2Plug.Response.id/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Response.html#t:method/0","title":"JSONRPC2Plug.Response.method/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Response.html#t:params/0","title":"JSONRPC2Plug.Response.params/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Response.html#t:t/0","title":"JSONRPC2Plug.Response.t/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Service.html","title":"JSONRPC2Plug.Service","type":"module"},{"doc":"Define method and handler. Example: method &quot;add&quot; , AddMethod method :subtract , SubtractMethod","ref":"JSONRPC2Plug.Service.html#method/2","title":"JSONRPC2Plug.Service.method/2","type":"macro"},{"doc":"","ref":"JSONRPC2Plug.Validator.html","title":"JSONRPC2Plug.Validator","type":"module"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#exclude/1","title":"JSONRPC2Plug.Validator.exclude/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#format/1","title":"JSONRPC2Plug.Validator.format/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#include/1","title":"JSONRPC2Plug.Validator.include/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#len/1","title":"JSONRPC2Plug.Validator.len/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#not_empty/0","title":"JSONRPC2Plug.Validator.not_empty/0","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#number/1","title":"JSONRPC2Plug.Validator.number/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#required/0","title":"JSONRPC2Plug.Validator.required/0","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#type/1","title":"JSONRPC2Plug.Validator.type/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#unwrap/1","title":"JSONRPC2Plug.Validator.unwrap/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#validate/3","title":"JSONRPC2Plug.Validator.validate/3","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.html#t:validator/0","title":"JSONRPC2Plug.Validator.validator/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Dataset.html","title":"JSONRPC2Plug.Validator.Dataset","type":"module"},{"doc":"","ref":"JSONRPC2Plug.Validator.Dataset.html#add_error/3","title":"JSONRPC2Plug.Validator.Dataset.add_error/3","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Dataset.html#get_value/2","title":"JSONRPC2Plug.Validator.Dataset.get_value/2","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Dataset.html#unwrap/1","title":"JSONRPC2Plug.Validator.Dataset.unwrap/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Dataset.html#wrap/1","title":"JSONRPC2Plug.Validator.Dataset.wrap/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Dataset.html#t:dataset/0","title":"JSONRPC2Plug.Validator.Dataset.dataset/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Dataset.html#t:t/0","title":"JSONRPC2Plug.Validator.Dataset.t/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Dataset.html#t:unwrapped/0","title":"JSONRPC2Plug.Validator.Dataset.unwrapped/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Exclusion.html","title":"JSONRPC2Plug.Validator.Exclusion","type":"module"},{"doc":"","ref":"JSONRPC2Plug.Validator.Exclusion.html#check/2","title":"JSONRPC2Plug.Validator.Exclusion.check/2","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Exclusion.html#rule/1","title":"JSONRPC2Plug.Validator.Exclusion.rule/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Inclusion.html","title":"JSONRPC2Plug.Validator.Inclusion","type":"module"},{"doc":"","ref":"JSONRPC2Plug.Validator.Inclusion.html#check/2","title":"JSONRPC2Plug.Validator.Inclusion.check/2","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Inclusion.html#rule/1","title":"JSONRPC2Plug.Validator.Inclusion.rule/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Length.html","title":"JSONRPC2Plug.Validator.Length","type":"module"},{"doc":"","ref":"JSONRPC2Plug.Validator.Length.html#check/2","title":"JSONRPC2Plug.Validator.Length.check/2","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Length.html#rule/1","title":"JSONRPC2Plug.Validator.Length.rule/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Number.html","title":"JSONRPC2Plug.Validator.Number","type":"module"},{"doc":"","ref":"JSONRPC2Plug.Validator.Number.html#check/2","title":"JSONRPC2Plug.Validator.Number.check/2","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Number.html#rule/1","title":"JSONRPC2Plug.Validator.Number.rule/1","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Rule.html","title":"JSONRPC2Plug.Validator.Rule","type":"behaviour"},{"doc":"","ref":"JSONRPC2Plug.Validator.Rule.html#c:check/2","title":"JSONRPC2Plug.Validator.Rule.check/2","type":"callback"},{"doc":"","ref":"JSONRPC2Plug.Validator.Rule.html#c:rule/1","title":"JSONRPC2Plug.Validator.Rule.rule/1","type":"callback"},{"doc":"","ref":"JSONRPC2Plug.Validator.Rule.html#t:error/0","title":"JSONRPC2Plug.Validator.Rule.error/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Rule.html#t:ok/0","title":"JSONRPC2Plug.Validator.Rule.ok/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Rule.html#t:opts/0","title":"JSONRPC2Plug.Validator.Rule.opts/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Rule.html#t:result/0","title":"JSONRPC2Plug.Validator.Rule.result/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Rule.html#t:rule/0","title":"JSONRPC2Plug.Validator.Rule.rule/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Rule.html#t:value/0","title":"JSONRPC2Plug.Validator.Rule.value/0","type":"type"},{"doc":"","ref":"JSONRPC2Plug.Validator.Type.html","title":"JSONRPC2Plug.Validator.Type","type":"module"},{"doc":"","ref":"JSONRPC2Plug.Validator.Type.html#check/2","title":"JSONRPC2Plug.Validator.Type.check/2","type":"function"},{"doc":"","ref":"JSONRPC2Plug.Validator.Type.html#rule/1","title":"JSONRPC2Plug.Validator.Type.rule/1","type":"function"}]